RTEMS: POSIX Priority Support

| RTEMS 5.4-rc2

Loading...
Searching...
No Matches
Files | Macros | Functions
POSIX Priority Support
Internal » RTEMS POSIX API

Interface to the POSIX Priority Implementation. More...

## Files
file | psxpriorityisvalid.c
| POSIX Is Priority Valid.

## Macros
#define | POSIX_SCHEDULER_MINIMUM_PRIORITY (1)

## Functions
RTEMS_INLINE_ROUTINE int | _POSIX_Priority_Get_maximum (const Scheduler_Control *scheduler)
| Gets the maximum POSIX API priority for this scheduler instance.
Priority_Control | _POSIX_Priority_To_core (const Scheduler_Control *scheduler, int priority, bool *valid)
| Converts the POSIX API priority to the corresponding SuperCore priority and validates it.
int | _POSIX_Priority_From_core (const Scheduler_Control *scheduler, Priority_Control priority)
| Converts the SuperCore priority to the corresponding POSIX API priority.

## Detailed Description

Interface to the POSIX Priority Implementation.

## Macro Definition Documentation

## ◆ POSIX_SCHEDULER_MINIMUM_PRIORITY

#define POSIX_SCHEDULER_MINIMUM_PRIORITY (1)

This is the numerically least important POSIX priority.

## Function Documentation

## ◆ _POSIX_Priority_From_core()

int _POSIX_Priority_From_core | ( | const Scheduler_Control * | scheduler,
|  | Priority_Control | priority
| ) |  |

Converts the SuperCore priority to the corresponding POSIX API priority.

Parameters

  [in] | scheduler | The scheduler instance.
  [in] | priority | The SuperCore priority to convert.

Returns
  The corresponding POSIX API priority.

## ◆ _POSIX_Priority_Get_maximum()

RTEMS_INLINE_ROUTINE int _POSIX_Priority_Get_maximum | ( | const Scheduler_Control * | scheduler | ) |

Gets the maximum POSIX API priority for this scheduler instance.

Such a priority is valid. A scheduler instance may support priority values that are not representable as an integer.

Returns
  The maximum POSIX API priority for this scheduler instance.

## ◆ _POSIX_Priority_To_core()

Priority_Control _POSIX_Priority_To_core | ( | const Scheduler_Control * | scheduler,
|  | int | priority,
|  | bool * | valid
| ) |  |

Converts the POSIX API priority to the corresponding SuperCore priority and validates it.

According to POSIX, numerically higher values represent higher priorities. Thus, SuperCore has priorities run in the opposite sense of the POSIX API.

Let N be the maximum priority of this scheduler instance. The SuperCore priority zero is system reserved (PRIORITY_PSEUDO_ISR). There are only N - 1 POSIX API priority levels since a thread at SuperCore priority N would never run because of the idle threads. This is necessary because GNAT maps the lowest Ada task priority to the lowest thread priority. The lowest priority Ada task should get to run, so there is a fundamental conflict with having N priorities.

Parameters

  [in] | scheduler | The scheduler instance.
  [in] | priority | The POSIX API priority to convert and validate.
  [out] | valid | Indicates if the POSIX API priority is valid and a corresponding SuperCore priority in the specified scheduler instance exists.

Returns
  The corresponding SuperCore priority.